corrModel<-function(normInt,method,modClasses,log=TRUE,nComps=1,plot=TRUE,printCDF=FALSE,dir2print="correctedCDFs"){
  
  normInt@corrInfo@log <- log
  
  if(method=="cpca"){
    normInt@corrInfo@corrMethod <- "cpca"
    normInt@corrInfo@modClasses <- modClasses
    normInt@corrInfo@nComps <- nComps
    aux <- cpcs(input=normInt,modClasses=modClasses,log=log,nComps=nComps,plot=plot)
    normInt@corrInfo@corrModel <- aux$out
    normInt@corrInfo@explVariance <- aux$variance
    normInt <- correction(normInt=normInt,printCDF=printCDF,plot=plot)
  }

  if(method=="cpcaMed"){
    normInt <- cpcsMed(normInt=normInt,modClasses=modClasses,log=log,nComps=nComps,plot=plot)
  }

  
    if(method=="artursson"){
    normInt@corrInfo@corrMethod <- "artursson"
    normInt@corrInfo@modClasses <- modClasses
    normInt@corrInfo@nComps <- nComps
    aux <- artursson(input=normInt,modClasses=modClasses,log=log,nComps=nComps,plot=plot)
    normInt@corrInfo@corrModel <- aux$out
    normInt@corrInfo@explVariance <- aux$variance
    normInt <- correction(normInt=normInt,printCDF=printCDF,plot=plot)
  }

      if(method=="medians"){
    normInt@corrInfo@corrMethod <- "medians"
    aux <- medians(input=normInt,plot=plot)
    normInt@corrInfo@corrModel <- aux$n
    normInt@corrInfo@corrData <- aux$data
  }


      if(method=="batch"){
    normInt@corrInfo@corrMethod <- "batch"
#    normInt@corrInfo@modClasses <- modClasses
#    normInt@corrInfo@nComps <- nComps
    aux <- batchEffects(input=normInt,log=log,plot=plot)
    normInt@corrInfo@corrData <- aux$out
    normInt@corrInfo@explVariance <- aux$variance
  }

if(method=="medians"|method=="batch"|method=="cpcaMed"){
  
  if(length(normInt@rawInfo@outliers)!=0){
data <- normInt@rawInfo@data
}else{
  data <- normInt@rawInfo@rawData
}
    classes <- normInt@rawInfo@classes
    Xc <- normInt@corrInfo@corrData

    


cat("Computing Regression indices...",fill=TRUE)

  data<-(normInt@rawInfo@data)
Xc<-(normInt@corrInfo@corrData)
data <- t(scale(log10(t(data+1)),center=TRUE,scale=TRUE))
  Xc <- t(scale(log10(t(Xc-min(Xc)+1)),center=TRUE,scale=TRUE))

  
  n <- 0

  if(length(normInt@rawInfo@time)!=0){n <- n+1}
  if(length(normInt@rawInfo@column)!=0){n <- n+1}
  if(length(normInt@rawInfo@batch)!=0){n <- n+1}

  normInt@corrInfo@regression <- vector("list",length=n)
i <- 0
if(length(normInt@rawInfo@time)!=0){
  i <- i+1
  time <- normInt@rawInfo@time
  timeEffectRaw <- p.adjust(apply(X=data,1,FUN=test,par=time))
  timeEffectCorr <- p.adjust(apply(X=(Xc),1,FUN=test,par=time))
  #if(plot){
 #   dev.new()
 # plot(-log10(timeEffectRaw),type="l",col=1,xlab="Retention Time",ylab="-log10(p-value)",main="Time regression")
 # lines(-log10(timeEffectCorr),type="l",new=FALSE,col=2)
 # legend("topleft",legend=c("Raw","Normalised"),pch=16,col=c(1,2))
#}
  aux <- list(timeEffectRaw,timeEffectCorr)
  names(aux) <- c("TimeEffectRaw","TimeEffectCorr")
  normInt@corrInfo@regression[[i]] <- aux
#  cat("",fill=TRUE)
#  cat("The mean p-value for Raw time regression is:",mean(normInt@corrInfo@regression[[i]]$TimeEffectRaw),fill=TRUE)
#  cat("The mean p-value for Normalised time regression is:",mean(normInt@corrInfo@regression[[i]]$TimeEffectCorr),fill=TRUE)
}

  if(length(normInt@rawInfo@column)!=0){
  i <- i+1
  column <- normInt@rawInfo@column
  columnEffectRaw <- p.adjust(apply(X=data,1,FUN=test,par=column))
  columnEffectCorr <- p.adjust(apply(X=(Xc),1,FUN=test,par=column))
  #if(plot){
  #  dev.new()
  #plot(-log10(columnEffectRaw),type="l",col=1,xlab="Retention Time",ylab="-log10(p-value)",main="Column regression")
 # lines(-log10(columnEffectCorr),type="l",new=FALSE,col=2)
#  legend("topleft",legend=c("Raw","Normalised"),pch=16,col=c(1,2))
#}
    aux <- list(columnEffectRaw,columnEffectCorr)
  names(aux) <- c("ColumnEffectRaw","ColumnEffectCorr")
  normInt@corrInfo@regression[[i]] <- aux
 # cat("",fill=TRUE)
 # cat("The mean p-value for Raw column regression is:",mean(normInt@corrInfo@regression[[i]]$ColumnEffectRaw),fill=TRUE)
 # cat("The mean p-value for Normalised column regression is:",mean(normInt@corrInfo@regression[[i]]$ColumnEffectCorr),fill=TRUE)

}


    if(length(normInt@rawInfo@batch)!=0){
  i <- i+1
  batch <- normInt@rawInfo@batch
  batchEffectRaw <- p.adjust(apply(X=data,1,FUN=test,par=batch))
  batchEffectCorr <- p.adjust(apply(X=(Xc),1,FUN=test,par=batch))
#  if(plot){
#    dev.new()
#  plot(-log10(batchEffectRaw),type="l",col=1,xlab="Retention Time",ylab="-log10(p-value)",main="Batch regression")
#  lines(-log10(batchEffectCorr),type="l",new=FALSE,col=2)
#  legend("topleft",legend=c("Raw","Normalised"),pch=16,col=c(1,2))
#}
      aux <- list(batchEffectRaw,batchEffectCorr)
  names(aux) <- c("BatchEffectRaw","BatchEffectCorr")
  normInt@corrInfo@regression[[i]] <- aux
#  cat("",fill=TRUE)
#  cat("The mean p-value for Raw batch regression is:",mean(normInt@corrInfo@regression[[i]]$BatchEffectRaw),fill=TRUE)
#  cat("The mean p-value for Normalised batch regression is:",mean(normInt@corrInfo@regression[[i]]$BatchEffectCorr),fill=TRUE)

}

data<-(normInt@rawInfo@data)
Xc<-(normInt@corrInfo@corrData)
data <- t(scale(log10(t(data+1)),center=TRUE,scale=TRUE))
  Xc <- t(scale(log10(t(Xc-min(Xc)+1)),center=TRUE,scale=TRUE))

  cat("",fill=TRUE)
  cat("Computing Dunn indices ... ",fill=TRUE)

    rawMod <- prcomp(t(data))
    corrMod <- prcomp(t(Xc))


  internRaw <- as.numeric(clValid(rawMod$x[!classes=="sample",1:2], 3, clMethods="kmeans",validation="internal")@measures)[2]
 internCorr <- as.numeric(clValid(corrMod$x[!classes=="sample",1:2], 3, clMethods="kmeans",validation="internal")@measures)[2]

   #   internRaw <- as.numeric(clValid(data[,!classes=="sample"], 3, clMethods="kmeans",validation="internal")@measures)[2]
    #internCorr <- as.numeric(clValid(Xc[,!classes=="sample"], 3, clMethods="kmeans",validation="internal")@measures)[2]

  cat("Raw Dunn index = ",internRaw,fill=TRUE)
  cat("Corrected Dunn index = ",internCorr,fill=TRUE)

    cat("Raw Data",fill=TRUE)
 show(clValid(rawMod$x[!classes=="sample",1:2], 3, clMethods=c("kmeans","hierarchical"),validation="internal")@measures)
    cat("Corrected Data",fill=TRUE)
 show(clValid(corrMod$x[!classes=="sample",1:2], 3, clMethods=c("kmeans","hierarchical"),validation="internal")@measures)


  
out <- c(internRaw,internCorr)
names(out) <- c("Dunn","DunnCorr")

normInt@corrInfo@dunn <- out
if(plot){
model<-prcomp(log10(t(normInt@corrInfo@corrData+1)),scale=TRUE)
dev.new()
plot(model$x[,1],model$x[,2],col=as.numeric(as.factor(normInt@rawInfo@classes)),pch=16,cex=0.8,main="Corrected Data PCA Scoreplot",xlab=paste("PC1 (",round(summary(model)$importance[2,1]*100,1),"%)",sep=""),ylab=paste("PC2 (",round(summary(model)$importance[2,2]*100,1),"%)",sep=""),sub="Classes")
legend("topright",pch=16,col=1:length(levels(as.factor(normInt@rawInfo@classes))),legend=levels(as.factor(normInt@rawInfo@classes)),bg=grey(0.9))
}

    
    
  }

  
  return(normInt)
}
  test <- function(x,par){return(anova(lm(x~par))$Pr[1])}
