correction<-function(normInt,plot=TRUE,printCDF=FALSE,dir2print="correctedCDFs"){
  if(length(normInt@rawInfo@outliers)!=0){
data <- normInt@rawInfo@data
}else{
  data <- normInt@rawInfo@rawData
}
  if(normInt@corrInfo@log==TRUE){
  dat <- scale(log10(t(data+1)),center=TRUE,scale=TRUE)
}else{
  dat <- scale(t(data),center=TRUE,scale=TRUE)
}

cat("Correcting Intensity Drift...")
  
  if(normInt@corrInfo@corrMethod=="cpca"){    
Xc <- dat-((dat %*% normInt@corrInfo@corrModel)%*%t(normInt@corrInfo@corrModel))
   XcRes <- Xc
   for (i in c(1:dim(dat)[2])){
      XcRes[,i] <- (Xc[,i]*attributes(dat)$`scaled:scale`[i])+attributes(dat)$`scaled:center`[i]
   }
   Xc <- XcRes

}

  if(normInt@corrInfo@corrMethod=="artursson"){    
Xc <- dat-((dat %*% normInt@corrInfo@corrModel)%*%t(normInt@corrInfo@corrModel))
   XcRes <- Xc
   for (i in c(1:dim(dat)[2])){
      XcRes[,i] <- (Xc[,i]*attributes(dat)$`scaled:scale`[i])+attributes(dat)$`scaled:center`[i]
   }
   Xc <- XcRes
}

  
 normInt@corrInfo@corrData<-t(Xc)
# if(normInt@corrInfo@log==TRUE){

if(plot){
  dev.new()
#  heatmap.2(Xc,trace="none",Rowv=FALSE,Colv=FALSE,dendrogram="none",main="Normalised Signal (log scale)",xlab="rt")
heatmap.2(main="Corrected Signal (log scale)",x=t(normInt@corrInfo@corrData),trace="none",Rowv=FALSE,Colv=FALSE,dendrogram="none",xlab="Retention Time (min)",ylab="Sample",col=rev(grey(0:15/15)))

 } 

normInt@corrInfo@corrData <- 10^normInt@corrInfo@corrData

#}else{



cat("Done!",fill=TRUE)


#}

  
  if(printCDF){
cat("Printing corrected cdf files...")
cdfFileCreator(dataMatrix=normInt@corrInfo@corrData,dir2print=dir2print,scanRange=normInt@rawInfo@scanRange,dataDir=normInt@rawInfo@rawDir)
cat("Done!")
  }
  
model<-prcomp(log10(t(data+1)),scale=TRUE)
    if(normInt@corrInfo@log==TRUE){
modelCorr<-prcomp(log10((Xc-min(Xc)+1)),scale=TRUE)
}else{
 # modelCorr<-prcomp(log10(t(normInt@corrInfo@corrData)),scale=TRUE)
modelCorr<-prcomp(Xc,scale=TRUE)
}

modClasses <- normInt@corrInfo@modClasses
  cat("",fill=TRUE)


  
classes <- normInt@rawInfo@classes
#ind <- vector("list",length=length(modClasses))
#means <-vector("list",length=length(modClasses))
#vars <- vector("list",length=length(modClasses))

 # names(ind) <- modClasses
  #names(means) <- modClasses
  #names(vars) <- modClasses

 #for(i in c(1:length(modClasses))){
 #  ind[[i]] <- which(classes==modClasses[i])
 #  means[[i]] <- colMeans(model$x[ind[[i]],1:2])
 #  vars[[i]] <- sd(model$x[ind[[i]],1:2])^2  
 #}

#Js <- choose(length(modClasses),2)
#J <- numeric(length=Js)
#k <- 1
#for(i in c(1:(Js-1))){
#  for(j in c((i+1):(Js))){
#J[k] <- sum((means[[i]]-means[[j]])^2)/(vars[[i]]+vars[[j]])
#k <- k+1
#}
#}



#meansCorr <-vector("list",length=length(modClasses))
#varsCorr <- vector("list",length=length(modClasses))

  #names(ind) <- modClasses
 # names(meansCorr) <- modClasses
#  names(varsCorr) <- modClasses

 #for(i in c(1:length(modClasses))){
   #ind[[i]] <- which(classes==modClasses[i])
  # meansCorr[[i]] <- colMeans(modelCorr$x[ind[[i]],1:2])
 #  varsCorr[[i]] <- sd(modelCorr$x[ind[[i]],1:2])^2  
# }

#JCorr <- numeric(length=Js)
#k <- 1
#for(i in c(1:(Js-1))){
#  for(j in c((i+1):(Js))){
#JCorr[k] <- sum((meansCorr[[i]]-meansCorr[[j]])^2)/(varsCorr[[i]]+varsCorr[[j]])
#k <- k+1
#}
#}


  cat("",fill=TRUE)

cat("Computing Regression indices...",fill=TRUE)

  
  n <- 0

  if(length(normInt@rawInfo@time)!=0){n <- n+1}
  if(length(normInt@rawInfo@column)!=0){n <- n+1}
  if(length(normInt@rawInfo@batch)!=0){n <- n+1}
  
  data<-(normInt@rawInfo@data)
Xc<-(normInt@corrInfo@corrData)
data <- t(scale(log10(t(data+1)),center=TRUE,scale=TRUE))
  Xc <- t(scale(log10(t((Xc-min(Xc)+1))),center=TRUE,scale=TRUE))

  normInt@corrInfo@regression <- vector("list",length=n)
i <- 0
if(length(normInt@rawInfo@time)!=0){
  i <- i+1
  time <- normInt@rawInfo@time
  timeEffectRaw <- p.adjust(apply(X=data,1,FUN=test,par=time))
  timeEffectCorr <- p.adjust(apply(X=(Xc),1,FUN=test,par=time))
#  if(plot){
#    dev.new()
#  plot(-log10(timeEffectRaw),type="l",col=1,xlab="Retention Time",ylab="-log10(p-value)",main="Time regression")
#  lines(-log10(timeEffectCorr),type="l",new=FALSE,col=2)
#  legend("topleft",legend=c("Raw","Normalised"),pch=16,col=c(1,2))
#}
  aux <- list(timeEffectRaw,timeEffectCorr)
  names(aux) <- c("TimeEffectRaw","TimeEffectCorr")
  normInt@corrInfo@regression[[i]] <- aux
  cat("",fill=TRUE)
#  cat("The mean p-value for Raw time regression is:",mean(normInt@corrInfo@regression[[i]]$TimeEffectRaw),fill=TRUE)
#  cat("The mean p-value for Normalised time regression is:",mean(normInt@corrInfo@regression[[i]]$TimeEffectCorr),fill=TRUE)
}

  if(length(normInt@rawInfo@column)!=0){
  i <- i+1
  column <- normInt@rawInfo@column
  columnEffectRaw <- p.adjust(apply(X=data,1,FUN=test,par=column))
  columnEffectCorr <- p.adjust(apply(X=(Xc),1,FUN=test,par=column))
#  if(plot){
#    dev.new()
#  plot(-log10(columnEffectRaw),type="l",col=1,xlab="Retention Time",ylab="-log10(p-value)",main="Column regression")
#  lines(-log10(columnEffectCorr),type="l",new=FALSE,col=2)
#  legend("topleft",legend=c("Raw","Normalised"),pch=16,col=c(1,2))
#}
    aux <- list(columnEffectRaw,columnEffectCorr)
  names(aux) <- c("ColumnEffectRaw","ColumnEffectCorr")
  normInt@corrInfo@regression[[i]] <- aux
  cat("",fill=TRUE)
#  cat("The mean p-value for Raw column regression is:",mean(normInt@corrInfo@regression[[i]]$ColumnEffectRaw),fill=TRUE)
#  cat("The mean p-value for Normalised column regression is:",mean(normInt@corrInfo@regression[[i]]$ColumnEffectCorr),fill=TRUE)

}


    if(length(normInt@rawInfo@batch)!=0){
  i <- i+1
  batch <- normInt@rawInfo@batch
  batchEffectRaw <- p.adjust(apply(X=data,1,FUN=test,par=batch))
  batchEffectCorr <- p.adjust(apply(X=(Xc),1,FUN=test,par=batch))
#  if(plot){
#    dev.new()
#  plot(-log10(batchEffectRaw),type="l",col=1,xlab="Retention Time",ylab="-log10(p-value)",main="Batch regression")
#  lines(-log10(batchEffectCorr),type="l",new=FALSE,col=2)
#  legend("topleft",legend=c("Raw","Normalised"),pch=16,col=c(1,2))
#}
      aux <- list(batchEffectRaw,batchEffectCorr)
  names(aux) <- c("BatchEffectRaw","BatchEffectCorr")
  normInt@corrInfo@regression[[i]] <- aux
  cat("",fill=TRUE)
#  cat("The mean p-value for Raw batch regression is:",mean(normInt@corrInfo@regression[[i]]$BatchEffectRaw),fill=TRUE)
#  cat("The mean p-value for Normalised batch regression is:",mean(normInt@corrInfo@regression[[i]]$BatchEffectCorr),fill=TRUE)

}





  data<-(normInt@rawInfo@data)
Xc<-(normInt@corrInfo@corrData)
data <- t(scale(log10(t(data+1)),center=TRUE,scale=TRUE))
  Xc <- t(scale(log10(t(Xc+1)),center=TRUE,scale=TRUE))

  cat("",fill=TRUE)
  cat("Computing Dunn indices ... ",fill=TRUE)

    rawMod <- prcomp(t(data))
    corrMod <- prcomp(t(Xc))


  internRaw <- as.numeric(clValid(rawMod$x[!classes=="sample",1:2], 3, clMethods="kmeans",validation="internal")@measures)[2]
 internCorr <- as.numeric(clValid(corrMod$x[!classes=="sample",1:2], 3, clMethods="kmeans",validation="internal")@measures)[2]



  
#internRaw <- as.numeric(clValid(data[,!classes=="sample"], 3, clMethods="kmeans",validation="internal")@measures)[2]
#internCorr <- as.numeric(clValid((Xc)[,!classes=="sample"], 3, clMethods="kmeans",validation="internal")@measures)[2]

  cat("Raw Dunn index = ",internRaw,fill=TRUE)
  cat("Corrected Dunn index = ",internCorr,fill=TRUE)


  cat("Raw Data",fill=TRUE)
 show(clValid(rawMod$x[!classes=="sample",1:2], 3, clMethods="kmeans",validation="internal")@measures)
    cat("Corrected Data",fill=TRUE)
 show(clValid(corrMod$x[!classes=="sample",1:2], 3, clMethods="kmeans",validation="internal")@measures)

  
if(plot){
model<-prcomp(log10(t(normInt@corrInfo@corrData+1)),scale=TRUE)
dev.new()
plot(model$x[,1],model$x[,2],col=as.numeric(as.factor(normInt@rawInfo@classes)),pch=16,cex=0.8,main="Corrected Data PCA Scoreplot",xlab=paste("PC1 (",round(summary(model)$importance[2,1]*100,1),"%)",sep=""),ylab=paste("PC2 (",round(summary(model)$importance[2,2]*100,1),"%)",sep=""),sub="Classes")
legend("topright",pch=16,col=1:length(levels(as.factor(normInt@rawInfo@classes))),legend=levels(as.factor(normInt@rawInfo@classes)),bg=grey(0.9))
}

  
out <- c(internRaw,internCorr)
names(out) <- c("Dunn","DunnCorr")

normInt@corrInfo@dunn <- out

  
  
  return(normInt)
  
}


  test <- function(x,par){return(anova(lm(x~par))$Pr[1])}








