setClass("Raw",
         representation(
                        rawDir="character",
                        rawData="matrix",
                        data="matrix",
                        classes="character",
                        scanRange="numeric",
                        DOE="character",
                        time="numeric",
                        column="numeric",
                        batch="factor",
                        outliers="list"
                        ),
         prototype(
                        rawDir=character(),
                        rawData=matrix(),
                        data=matrix(),
                        classes=character(),
                        scanRange=numeric(),
                        DOE=character(),
                        time=numeric(),
                        column=numeric(),
                        batch=factor(),
                        outliers=list()
			)
         );

setClass("Corrected",
         representation(
                        corrMethod="character",
                        corrModel="matrix",
                        corrData="matrix",
                        modClasses="character",
                        nComps="numeric",
                        explVariance="numeric",
                        log="logical",
                        dunn="numeric",
                        regression="list"
                        ),
         prototype(
                        corrMethod=character(),
                        corrModel=matrix(),
                        corrData=matrix(),
                        modClasses=character(),
                        nComps=numeric(),
                        explVariance=numeric(),
                        log=logical(),
                        dunn=numeric(),
                        regression=list()
			)
         );
setClass("normInt",
         representation(
                        rawInfo="Raw",
                        corrInfo="Corrected"
                        ),
         prototype(
                        rawInfo=new("Raw"),
                        corrInfo=new("Corrected")
			)
         );
